/* Copyright 2008 Daniel Vokó <vokoda@gmail.com>
 * 
 * This file is part of Sagittarius.
 *
 * Sagittarius is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sagittarius is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Sagittarius.  If not, see <http://www.gnu.org/licenses/>.
 */


using System;
using System.Globalization;
using System.Collections;
using Sagittarius.Metadata;
using Sagittarius.Widgets;
using Sagittarius.Exiftool;

namespace Sagittarius
{
	public partial class EditIptcDialog : Gtk.Dialog
	{
		//private Sagittarius.MainClass mainClass;
		//private MetadataSection iptcSect;
		private MetadataSection newSection;
		public EditIptcDialog(MetadataSection iptcSect)
		{
			//Console.WriteLine("Entering EditIptcDialog constructor");
			this.Build();
			
			//this.iptcSect=iptcSect;
			newSection=new MetadataSection();

			creCreEnt.Sensitive=creCreCb.Active;
			creJobEnt.Sensitive=creJobCb.Active;
			creAddEnt.Sensitive=creAddCb.Active;
			creCitEnt.Sensitive=creCitCb.Active;
			creStaEnt.Sensitive=creStaCb.Active;
			crePosEnt.Sensitive=crePosCb.Active;
			creCouEnt.Sensitive=creCouCb.Active;
			creTelEnt.Sensitive=creTelCb.Active;
			creEmaEnt.Sensitive=creEmaCb.Active;
			creWebEnt.Sensitive=creWebCb.Active;
			conHeaEnt.Sensitive=conHeaCb.Active;
			conCapEnt.Sensitive=conCapCb.Active;
			conIptEnt.Sensitive=conIptCb.Active;
			conWriEnt.Sensitive=conWriCb.Active;
			conKeyEnt.Sensitive=conKeyCb.Active;
			imaDatDtp.Sensitive=imaDatCb.Active;
			imaIntEnt.Sensitive=imaIntCb.Active;
			imaIptEnt.Sensitive=imaIptCb.Active;
			imaLocEnt.Sensitive=imaLocCb.Active;
			imaCitEnt.Sensitive=imaCitCb.Active;
			imaStaEnt.Sensitive=imaStaCb.Active;
			imaCouEnt.Sensitive=imaCouCb.Active;
			imaIsoEnt.Sensitive=imaIsoCb.Active;
			staTitEnt.Sensitive=staTitCb.Active;
			staJobEnt.Sensitive=staJobCb.Active;
			staInsEnt.Sensitive=staInsCb.Active;
			staProEnt.Sensitive=staProCb.Active;
			staSouEnt.Sensitive=staSouCb.Active;
			copStaCom.Sensitive=copStaCb.Active;
			copCopEnt.Sensitive=copCopCb.Active;
			copRigEnt.Sensitive=copRigCb.Active;
			
			creCreEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CREATOR);
			creJobEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CREATOR_JOB_TITLE);
			creAddEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_ADR_EXTADR);
			creCitEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_ADR_CITY);
			creStaEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_ADR_REGION);
			crePosEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_ADR_PCODE);
			creCouEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_ADR_CTRY);
			creTelEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_TEL_WORK);
			creEmaEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_EMAIL_WORK);
			creWebEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CI_URL_WORK);
			conHeaEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_HEADLINE);
			conCapEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_DESCRIPTION);
			conIptEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_SUBJECT_CODE);
			conWriEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_DESCRIPTION_WRITER);
			conKeyEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_KEYWORDS);
			string dateString = iptcSect.GetValue(ExiftoolTags.IPTC_DATE_CREATED);
			if((dateString !=Misc.MULTIPLE_VALUES)&&dateString.Length>0)
			{
				imaDatDtp.SetValueFromStandardString(dateString);
			}
			imaIntEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_INTELLECTUAL_GENRE);
			imaIptEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_SCENE);
			imaLocEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_LOCATION);
			imaCitEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_CITY);
			imaStaEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_PROVINCE_STATE);
			imaCouEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_COUNTRY);
			imaIsoEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_COUNTRY_CODE);
			staTitEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_TITLE);
			staJobEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_JOB_ID);
			staInsEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_INSTRUCTIONS);
			staProEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_PROVIDER);
			staSouEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_SOURCE);
			string copyRightString = iptcSect.GetValue(ExiftoolTags.IPTC_COPYRIGHTED);
			if (copyRightString =="True")
			{ copStaCom.Active=1; }
			else if (copyRightString == "False")
			{ copStaCom.Active = 0; }
			else
			{ copStaCom.Active = 2; }
			copCopEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_COPYRIGHT_NOTICE);
			copRigEnt.Text=iptcSect.GetValue(ExiftoolTags.IPTC_RIGHT_USAGE_TERMS);
			//Console.WriteLine("Leaving EditIptcDialog constructor");
		}

		protected virtual void OnCreCreCbClicked (object sender, System.EventArgs e)
		{
			creCreEnt.Sensitive=creCreCb.Active;
		}

		protected virtual void OnCreJobCbClicked (object sender, System.EventArgs e)
		{
			creJobEnt.Sensitive=creJobCb.Active;
		}

		protected virtual void OnCreAddCbClicked (object sender, System.EventArgs e)
		{
			creAddEnt.Sensitive=creAddCb.Active;
		}

		protected virtual void OnCreCitCbClicked (object sender, System.EventArgs e)
		{
			creCitEnt.Sensitive=creCitCb.Active;
		}

		protected virtual void OnCreStaCbClicked (object sender, System.EventArgs e)
		{
			creStaEnt.Sensitive=creStaCb.Active;
		}

		protected virtual void OnCreposCbClicked (object sender, System.EventArgs e)
		{
			crePosEnt.Sensitive=crePosCb.Active;
		}

		protected virtual void OnCreCouCbClicked (object sender, System.EventArgs e)
		{
			creCouEnt.Sensitive=creCouCb.Active;
		}

		protected virtual void OnCreTelCbClicked (object sender, System.EventArgs e)
		{
			creTelEnt.Sensitive=creTelCb.Active;
		}

		protected virtual void OnCreEmaCbClicked (object sender, System.EventArgs e)
		{
			creEmaEnt.Sensitive=creEmaCb.Active;
		}

		protected virtual void OnCreWebCbClicked (object sender, System.EventArgs e)
		{
			creWebEnt.Sensitive=creWebCb.Active;
		}

		protected virtual void OnConHeaCbClicked (object sender, System.EventArgs e)
		{
			conHeaEnt.Sensitive=conHeaCb.Active;
		}

		protected virtual void OnConCapCbClicked (object sender, System.EventArgs e)
		{
			conCapEnt.Sensitive=conCapCb.Active;
		}

		protected virtual void OnConIptCbClicked (object sender, System.EventArgs e)
		{
			conIptEnt.Sensitive=conIptCb.Active;
		}

		protected virtual void OnConWriCbClicked (object sender, System.EventArgs e)
		{
			conWriEnt.Sensitive=conWriCb.Active;
		}

		protected virtual void OnConKeyCbClicked (object sender, System.EventArgs e)
		{
			conKeyEnt.Sensitive=conKeyCb.Active;
		}

		protected virtual void OnImaDatCbClicked (object sender, System.EventArgs e)
		{
			imaDatDtp.Sensitive=imaDatCb.Active;
		}

		protected virtual void OnImaIntCbClicked (object sender, System.EventArgs e)
		{
			imaIntEnt.Sensitive=imaIntCb.Active;
		}

		protected virtual void OnImaIptCbClicked (object sender, System.EventArgs e)
		{
			imaIptEnt.Sensitive=imaIptCb.Active;
		}

		protected virtual void OnImaLocCbClicked (object sender, System.EventArgs e)
		{
			imaLocEnt.Sensitive=imaLocCb.Active;
		}

		protected virtual void OnImaCitCbClicked (object sender, System.EventArgs e)
		{
			imaCitEnt.Sensitive=imaCitCb.Active;
		}

		protected virtual void OnImaStaCbClicked (object sender, System.EventArgs e)
		{
			imaStaEnt.Sensitive=imaStaCb.Active;
		}

		protected virtual void OnImaCouCbClicked (object sender, System.EventArgs e)
		{
			imaCouEnt.Sensitive=imaCouCb.Active;
		}

		protected virtual void OnImaIsoCbClicked (object sender, System.EventArgs e)
		{
			imaIsoEnt.Sensitive=imaIsoCb.Active;
		}

		protected virtual void OnStaTitCbClicked (object sender, System.EventArgs e)
		{
			staTitEnt.Sensitive=staTitCb.Active;
		}

		protected virtual void OnStaJobCbClicked (object sender, System.EventArgs e)
		{
			staJobEnt.Sensitive=staJobCb.Active;
		}

		protected virtual void OnStaInsCbClicked (object sender, System.EventArgs e)
		{
			staInsEnt.Sensitive=staInsCb.Active;
		}

		protected virtual void OnStaProCbClicked (object sender, System.EventArgs e)
		{
			staProEnt.Sensitive=staProCb.Active;
		}

		protected virtual void OnStaSouCbClicked (object sender, System.EventArgs e)
		{
			staSouEnt.Sensitive=staSouCb.Active;
		}

		protected virtual void OnCopStaCbClicked (object sender, System.EventArgs e)
		{
			copStaCom.Sensitive=copStaCb.Active;
		}

		protected virtual void OnCopCopCbClicked (object sender, System.EventArgs e)
		{
			copCopEnt.Sensitive=copCopCb.Active;
		}

		protected virtual void OnCopRigCbClicked (object sender, System.EventArgs e)
		{
			copRigEnt.Sensitive=copRigCb.Active;
		}

		protected virtual void OnResponse (object o, Gtk.ResponseArgs args)
		{
		}

		protected virtual void OnButtonOkClicked (object sender, System.EventArgs e)
		{
			//Console.WriteLine("Entering EditIptcDialog. OnButtonOkClicked");
			
			if (creCreCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CREATOR,creCreEnt.Text));
			if (creJobCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CREATOR_JOB_TITLE,creJobEnt.Text));
			if (creAddCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_ADR_EXTADR,creAddEnt.Text));
			if (creCitCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_ADR_CITY,creCitEnt.Text));
			if (creStaCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_ADR_REGION,creStaEnt.Text));
			if (crePosCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_ADR_PCODE,crePosEnt.Text));
			if (creCouCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_ADR_CTRY, creCouEnt.Text));
			if (creTelCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_TEL_WORK,creTelEnt.Text));
			if (creEmaCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_EMAIL_WORK, creEmaEnt.Text));
			if (creWebCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CI_URL_WORK, creWebEnt.Text));
			if (conHeaCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_HEADLINE, conHeaEnt.Text));
			if (conCapCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_DESCRIPTION, conCapEnt.Text));
			if (conIptCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_SUBJECT_CODE, conIptEnt.Text));
			if (conWriCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_DESCRIPTION_WRITER, conWriEnt.Text));
			if (conKeyCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_KEYWORDS, conKeyEnt.Text));
			if (imaDatCb.Active)
			{
				/*DateTime dt = imaDatDtp.Value;
				int timeZone = imaDatDtp.TimeZone;
				string tZ;
				if (timeZone<0)
				{
					tZ= timeZone.ToString()+":000";
				}
				else
				{
					tZ= "+"+timeZone.ToString()+":000";
				}
				if(tZ.Length==6)
				{
					tZ=tZ.Insert(1,"0");
				}
				string year = dt.Year.ToString();
				string month = dt.Month.ToString();
				if(month.Length==1)
				{
					month="0"+month;
				}
				string day = dt.Day.ToString();
				if(day.Length==1)
				{
					day="0"+day;
				}
				string hour = dt.Hour.ToString();
				if(hour.Length==1)
				{
					hour="0"+hour;
				}
				string minute = dt.Minute.ToString();
				if(minute.Length==1)
				{
					minute="0"+minute;
				}
				string second = dt.Second.ToString();
				if(second.Length==1)
				{
					second="0"+second;
				}
				string dateString=
					year+
					":"+
					month+
					":"+
					day+
					" "+
					hour+
					":"+
					minute+
					":"+
					second+
					"."+
					tZ;
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_DATE_CREATED, dateString));*/
				//Console.WriteLine(dateString);
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_DATE_CREATED,imaDatDtp.GetValueAsStandardString()));
			}
			if (imaIntCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_INTELLECTUAL_GENRE, imaIntEnt.Text));
			if (imaIptCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_SCENE, imaIptEnt.Text));
			if (imaLocCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_LOCATION, imaLocEnt.Text));
			if (imaCitCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_CITY, imaCitEnt.Text));
			if (imaStaCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_PROVINCE_STATE, imaStaEnt.Text));
			if (imaCouCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COUNTRY, imaCouEnt.Text));
			if (imaIsoCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COUNTRY_CODE, imaIsoEnt.Text));
			if (staTitCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_TITLE, staTitEnt.Text));
			if (staJobCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_JOB_ID, staJobEnt.Text));
			if (staInsCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_INSTRUCTIONS, staInsEnt.Text));
			if (staProCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_PROVIDER, staProEnt.Text));
			if (staSouCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_SOURCE, staSouEnt.Text));
			if (copCopCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COPYRIGHT_NOTICE, copCopEnt.Text));
			if (copStaCb.Active)
			{
				switch (copStaCom.Active)
				{
					case 0:
						newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COPYRIGHTED, "False"));
						break;
					case 1:
						newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COPYRIGHTED, "True"));
						break;
					default:
						newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COPYRIGHTED, ""));
						break;
				}
				//newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_COPYRIGHTED, copStaCom.Active.ToString()));
			}
			if (copRigCb.Active)
				newSection.AddElement(new MetadataElement(ExiftoolTags.IPTC_RIGHT_USAGE_TERMS, copRigEnt.Text));

			this.Respond(Gtk.ResponseType.Accept);
			//Console.WriteLine("Exiting EditIptcDialog. OnButtonOkClicked");
		}

		protected virtual void OnButtonCancelClicked (object sender, System.EventArgs e)
		{
			this.Respond(Gtk.ResponseType.Cancel);
		}
		
		public MetadataSection NewIptcSection
		{
			get { return newSection; }
		}

	}
}
